com.lowagie.text.pdf.internal

## Class PolylineShapeIterator

- java.lang.Object
- - com.lowagie.text.pdf.internal.PolylineShapeIterator

- All Implemented Interfaces:
    java.awt.geom.PathIterator

      public class PolylineShapeIterator
      extends java.lang.Object
      implements java.awt.geom.PathIterator

  PathIterator for PolylineShape. This class was originally written by wil - amristar.com.au and integrated into iText by Bruno.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected java.awt.geom.AffineTransform` | `affine` an affine transformation to be performed on the polyline.
    `protected int` | `index` the index of the current segment in the iterator.
    `protected PolylineShape` | `poly` The polyline over which we are going to iterate.

    - ### Fields inherited from interface java.awt.geom.PathIterator

      `SEG_CLOSE, SEG_CUBICTO, SEG_LINETO, SEG_MOVETO, SEG_QUADTO, WIND_EVEN_ODD, WIND_NON_ZERO`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `PolylineShapeIterator(PolylineShape l, java.awt.geom.AffineTransform at)` Creates a PolylineShapeIterator.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `currentSegment(double[] coords)` Returns the coordinates and type of the current path segment in the iteration.
    `int` | `currentSegment(float[] coords)` Returns the coordinates and type of the current path segment in the iteration.
    `int` | `getWindingRule()` Return the winding rule for determining the insideness of the path.
    `boolean` | `isDone()` Tests if there are more points to read.
    `void` | `next()` Moves the iterator to the next segment of the path forwards along the primary direction of traversal as long as there are more points in that direction.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### poly

          protected PolylineShape poly

      The polyline over which we are going to iterate.

    - #### affine

          protected java.awt.geom.AffineTransform affine

      an affine transformation to be performed on the polyline.

    - #### index

          protected int index

      the index of the current segment in the iterator.

  - ### Constructor Detail

    - #### PolylineShapeIterator

          PolylineShapeIterator(PolylineShape l,
                               java.awt.geom.AffineTransform at)

      Creates a PolylineShapeIterator.

  - ### Method Detail

    - #### currentSegment

          public int currentSegment(double[] coords)

      Returns the coordinates and type of the current path segment in the iteration. The return value is the path segment type: SEG_MOVETO, SEG_LINETO, SEG_QUADTO, SEG_CUBICTO, or SEG_CLOSE. A double array of length 6 must be passed in and may be used to store the coordinates of the point(s). Each point is stored as a pair of double x,y coordinates. SEG_MOVETO and SEG_LINETO types will return one point, SEG_QUADTO will return two points, SEG_CUBICTO will return 3 points and SEG_CLOSE will not return any points.
      Specified by:
        `currentSegment` in interface `java.awt.geom.PathIterator`
      See Also:
        `PathIterator.SEG_MOVETO`, `PathIterator.SEG_LINETO`, `PathIterator.SEG_QUADTO`, `PathIterator.SEG_CUBICTO`, `PathIterator.SEG_CLOSE`, `PathIterator.currentSegment(double[])`

    - #### currentSegment

          public int currentSegment(float[] coords)

      Returns the coordinates and type of the current path segment in the iteration. The return value is the path segment type: SEG_MOVETO, SEG_LINETO, SEG_QUADTO, SEG_CUBICTO, or SEG_CLOSE. A double array of length 6 must be passed in and may be used to store the coordinates of the point(s). Each point is stored as a pair of double x,y coordinates. SEG_MOVETO and SEG_LINETO types will return one point, SEG_QUADTO will return two points, SEG_CUBICTO will return 3 points and SEG_CLOSE will not return any points.
      Specified by:
        `currentSegment` in interface `java.awt.geom.PathIterator`
      See Also:
        `PathIterator.SEG_MOVETO`, `PathIterator.SEG_LINETO`, `PathIterator.SEG_QUADTO`, `PathIterator.SEG_CUBICTO`, `PathIterator.SEG_CLOSE`, `PathIterator.currentSegment(float[])`

    - #### getWindingRule

          public int getWindingRule()

      Return the winding rule for determining the insideness of the path.
      Specified by:
        `getWindingRule` in interface `java.awt.geom.PathIterator`
      See Also:
        `PathIterator.WIND_EVEN_ODD`, `PathIterator.WIND_NON_ZERO`, `PathIterator.getWindingRule()`

    - #### isDone

          public boolean isDone()

      Tests if there are more points to read.
      Specified by:
        `isDone` in interface `java.awt.geom.PathIterator`
      Returns:
        true if there are more points to read
      See Also:
        `PathIterator.isDone()`

    - #### next

          public void next()

      Moves the iterator to the next segment of the path forwards along the primary direction of traversal as long as there are more points in that direction.
      Specified by:
        `next` in interface `java.awt.geom.PathIterator`
      See Also:
        `PathIterator.next()`